//===========================================================================
//
// Name:			fw_items.c
// Function:		file to start with for fuzzy logic interbreeding sessions
// Programmer:		Mr Elusive (MrElusive@idsoftware.com)
// Author:		vagyok
// Last update:		2008-07-22
// Tab Size:		4 (real tabs)
// Notes:			-
//===========================================================================


//#define WEAPONS_STAY

//balance range
#define BR_ARMOR				30
#define BR_HEALTH				30
#define BR_WEAPON				30
#define BR_AMMO					30
#define BR_POWERUP				30

//balance macros
#define MZ(value)				(value) < 0 ? 0 : (value)
#define ARMOR_SCALE(v)			balance($evalfloat(MZ(FS_ARMOR*v)), $evalfloat(MZ(FS_ARMOR*v-BR_ARMOR)), $evalfloat(MZ(FS_ARMOR*v+BR_ARMOR)))
#define HEALTH_SCALE(v)			balance($evalfloat(MZ(FS_HEALTH*v)), $evalfloat(MZ(FS_HEALTH*v-BR_HEALTH)), $evalfloat(MZ(FS_HEALTH*v+BR_HEALTH)))
#define WEAPON_SCALE(v)			balance($evalfloat(MZ(v)), $evalfloat(MZ(v-BR_WEAPON)), $evalfloat(MZ(v+BR_WEAPON)))
#define AMMO_SCALE(v)			balance($evalfloat(MZ(v)), $evalfloat(MZ(v-BR_AMMO)), $evalfloat(MZ(v+BR_AMMO)))
#define POWERUP_SCALE(v)		balance($evalfloat(MZ(v)), $evalfloat(MZ(v-BR_POWERUP)), $evalfloat(MZ(v+BR_POWERUP)))

#define KNIFE_MAXAMMO				5
#define BERETTA_MAXAMMO				15
#define DEAGLE_MAXAMMO				7
#define SPAS12_MAXAMMO				6
#define UMP45_MAXAMMO				30
#define MP5K_MAXAMMO				30
#define M4_MAXAMMO				30
#define AK103_MAXAMMO				30
#define G36_MAXAMMO				30
#define PSG1_MAXAMMO				8
#define SR8_MAXAMMO				5
#define NEGEV_MAXAMMO				90
#define GRENADE_HE_MAXAMMO				2
#define GRENADE_SMOKE_MAXAMMO				2

//=============================================
// WEAPONS
//=============================================

weight "ut_weapon_knife"
{


	switch(INVENTORY_KNIFE_AMMO)


	{


		case KNIFE_MAXAMMO: return W_KNIFE;


		default: return 0;


	} //end switch


} //end weight
  

weight "ut_weapon_beretta"

{


	switch(INVENTORY_DEAGLE)

{



		case 1:
		{
			switch(INVENTORY_BERETTA_AMMO)

{
				case BERETTA_MAXAMMO: return W_BERETTA;


				default: return 1;
			}
		}
		default: return 0;
	} //end switch


} //end weight  

weight "ut_weapon_deagle"

{


	switch(INVENTORY_BERETTA)

{


		case 1:


		{
			switch(INVENTORY_DEAGLE_AMMO)

{
				case DEAGLE_MAXAMMO: return W_DEAGLE;
				default: return 1;


			}
		}
		default: return 0;
	} //end switch


} //end weight  

weight "ut_weapon_spas12"

{


	switch(INVENTORY_SPAS12)

{


		case 1:
		{
			switch(INVENTORY_MP5K){
				case 1:
				{
					switch(INVENTORY_UMP45){
						case 1:
						{
							switch(INVENTORY_NEGEV){
								case 1: return $evalint(W_SPAS12*2);
								default: return 0;
							}
						}
						default: return 0;
					}
				}
				default: return 0;
			}
		}
		default:


		{
			switch(INVENTORY_SPAS12_AMMO)

{
				case SPAS12_MAXAMMO: return W_SPAS12;
				default: return 1;


			}
		}
	} //end switch


} //end weight  

weight "ut_weapon_mp5k"

{


	switch(INVENTORY_MP5K)

{


		case 1:
		{
			switch(INVENTORY_SPAS12){
				case 1:
				{
					switch(INVENTORY_UMP45){
						case 1:
						{
							switch(INVENTORY_NEGEV){
								case 1: return $evalint(W_MP5K*2);
								default: return 0;
							}
						}
						default: return 0;
					}
				}
				default: return 0;
			}
		}
		default:


		{
			switch(INVENTORY_MP5K_AMMO)

{
				case MP5K_MAXAMMO: return W_MP5K;
				default: return 1;


			}
		}
	} //end switch


} //end weight  

weight "ut_weapon_ump45"

{


	switch(INVENTORY_UMP45)

{


		case 1:
		{
			switch(INVENTORY_MP5K){
				case 1:
				{
					switch(INVENTORY_SPAS12){
						case 1:
						{
							switch(INVENTORY_NEGEV){
								case 1: return $evalint(W_UMP45*2);
								default: return 0;
							}
						}
						default: return 0;
					}
				}
				default: return 0;
			}
		}
		default:


		{
			switch(INVENTORY_UMP45_AMMO)

{
				case UMP45_MAXAMMO: return W_UMP45;
				default: return 1;


			}
		}
	} //end switch


} //end weight  

weight "ut_weapon_m4"

{


	switch(INVENTORY_M4)
{


		case 1: return 0;


		default:

 
		{
			switch(INVENTORY_M4_AMMO)

{
				case M4_MAXAMMO: return W_M4;
				default: return 1;


			}
		}
	} //end switch


} //end weight  

weight "ut_weapon_g36"

{


	switch(INVENTORY_G36)

{


		case 1: return 0;


		default:


		{
			switch(INVENTORY_G36_AMMO)

{
				case G36_MAXAMMO: return W_G36;
				default: return 1;


			}
		}
	} //end switch


} //end weight  

weight "ut_weapon_psg1"

{


	switch(INVENTORY_PSG1)

{


		case 1: return 0;


		default:


		{
			switch(INVENTORY_PSG1_AMMO)

{
				case PSG1_MAXAMMO: return W_PSG1;
				default: return 1;


			}
		}
	} //end switch


} //end weight  

weight "ut_weapon_sr8"

{


	switch(INVENTORY_SR8)

{


		case 1: return 0;


		default:

		{
			switch(INVENTORY_SR8_AMMO)

{
				case SR8_MAXAMMO: return W_SR8;
				default: return 1;


			}
		}
	} //end switch


} //end weight  

weight "ut_weapon_ak103"

{


	switch(INVENTORY_AK103)

{


		case 1: return 0;


		default:


		{
			switch(INVENTORY_AK103_AMMO)

{
				case AK103_MAXAMMO: return W_AK103;
				default: return 1;


			}
		}

	} //end switch


} //end weight  

weight "ut_weapon_grenade_he"

{


	switch(INVENTORY_GRENADE_SMOKE)

{


		case 1:
		{
			switch(INVENTORY_GRENADE_HE_AMMO)

{
				case GRENADE_HE_MAXAMMO: return W_GRENADE_HE;
				default: return 0;


			}
		}


		default: return 0;
	} //end switch


} //end weight  

weight "ut_weapon_grenade_smoke"

{

	switch(INVENTORY_GRENADE_HE)

{


		case 1:
		{
			switch(INVENTORY_GRENADE_SMOKE_AMMO)

{
				case GRENADE_SMOKE_MAXAMMO: return W_GRENADE_SMOKE;
				default: return 0;


			}
		}


		default: return 0;
	} //end switch


} //end weight  

weight "ut_weapon_negev"

{


	switch(INVENTORY_NEGEV)

{


		case 1: return 0;


		default:


		{
			switch(INVENTORY_NEGEV_AMMO)

{
				case NEGEV_MAXAMMO: return W_NEGEV;
				default: return 1;


			}
		}

	} //end switch


} //end weight  


//=============================================
// This is only used to pickup dropped CTF
// flags now. The logic in here makes no
// sense since the bot has specific CTF AI.
//=============================================

weight "team_CTF_redflag" //Red Flag
{
	switch(INVENTORY_REDFLAG)
	{
		case 1: //not carrying the red flag
		{
			switch(INVENTORY_BLUEFLAG)
			{
				case 1: //not carrying the blue flag
				{
					return FLAG_WEIGHT;
				} //end case
				default: //bot carrying the blue flag so go back to the base
				{
					return 1500;
				} //end case
			} //end switch
		} //end case
		default: //bot carrying the red flag, so don't go back
		{
			return 0;
		} //end default
	} //end switch
} //end weight

weight "team_CTF_blueflag" //Blue Flag
{
	switch(INVENTORY_BLUEFLAG)
	{
		case 1: //not carrying the blue flag
		{
			switch(INVENTORY_REDFLAG)
			{
				case 1: //not carrying the red flag
				{
					return FLAG_WEIGHT;
				} //end case
				default: //bot is carrying the red flag so go back to the base
				{
					return 1500;
				} //end case
			} //end switch
		} //end case
		default: //bot is carrying the blue flag, so don't go back
		{
			return 0;
		} //end default
	} //end switch
} //end weight

weight "team_CTF_neutralflag" //Neutral Flag
{
	return FLAG_WEIGHT;
} //end weight

